﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;

public partial class _Default : System.Web.UI.Page
{

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            Session["ds1"] = DataSource();
            Session["ds2"] = DataSource2();
            WebDataGrid1.DataSource = DataSource();
            WebDataGrid2.DataSource = DataSource2();
        }
        else
        {
            int iRowCount = 0;
            string sUserId = "";
            bool bIncludeFlag = false;

            List<Person> list2 = new List<Person>();
            List<Person> list1 = new List<Person>();

            list1 = (List<Person>)Session["ds1"];
            list2 = (List<Person>)Session["ds2"];

            iRowCount = WebDataGrid1.Rows.Count;
            for (int i = 0; i < iRowCount; ++i)
            {
                sUserId = WebDataGrid1.Rows[i].Items[1].Value.ToString();
                if (WebDataGrid1.Rows[i].Items[0].FindControl("chkInclude") != null)
                {
                    bIncludeFlag = ((CheckBox)WebDataGrid1.Rows[i].Items[0].FindControl("chkInclude")).Checked;
                    foreach (Person userInfo in list1)
                    {
                        if (userInfo.ID == Convert.ToInt32(sUserId))
                            userInfo.IncludeFlag = bIncludeFlag;
                    }
                }
            }

            iRowCount = WebDataGrid2.Rows.Count;
            for (int i = 0; i < iRowCount; ++i)
            {
                sUserId = WebDataGrid2.Rows[i].Items[1].Value.ToString();
                if (WebDataGrid2.Rows[i].Items[0].FindControl("chkInclude") != null)
                {
                    bIncludeFlag = ((CheckBox)WebDataGrid2.Rows[i].Items[0].FindControl("chkInclude")).Checked;
                    foreach (Person userInfo in list2)
                    {
                        if (userInfo.ID == Convert.ToInt32(sUserId))
                            userInfo.IncludeFlag = bIncludeFlag;
                    }
                }
            }

            WebDataGrid1.ClearDataSource();
            WebDataGrid2.ClearDataSource();
            WebDataGrid1.DataSource = (List<Person>)Session["ds1"];
            WebDataGrid2.DataSource = (List<Person>)Session["ds2"];
            WebDataGrid2.DataBind();
            WebDataGrid1.DataBind();
        }
    }
    
    protected void MoveBtn_Click(object sender, EventArgs e)
    {
        List<Person> list2 = new List<Person>();
        List<Person> list1 = new List<Person>();

        list1 = (List<Person>)Session["ds1"];
        list2 = (List<Person>)Session["ds2"];

        foreach (GridRecord row in WebDataGrid1.Rows)
        {
            if (((CheckBox)row.Items[0].FindControl("chkInclude")).Checked)
            {
                Person p = new Person((int)row.Items[1].Value, row.Items[2].Value.ToString());
                list2.Add(p);
                
                foreach (Person info in list1)
                {
                    if (info.ID == p.ID)
                    {
                        p = info;
                        break;
                    }
                }
                list1.Remove(p);
            }
        }

        foreach (GridRecord row in WebDataGrid2.Rows)
        {
            if (((CheckBox)row.Items[0].FindControl("chkInclude")).Checked)
            {
                Person p = new Person((int)row.Items[1].Value, row.Items[2].Value.ToString());
                list1.Add(p);
                
                foreach (Person info in list2)
                {
                    if (info.ID == p.ID)
                    {
                        p = info;
                        break;
                    }
                }
                list2.Remove(p);
            }
        }

        WebDataGrid1.ClearDataSource();
        WebDataGrid2.ClearDataSource();
        WebDataGrid2.DataSource = list2;
        WebDataGrid1.DataSource = list1;
        WebDataGrid2.DataBind();
        WebDataGrid1.DataBind();

        Session["ds1"] = list1;
        Session["ds2"] = list2;
    }

    public List<Person> DataSource()
    {
        List<Person> list1 = new List<Person>();
        list1.Add(new Person(1, "Name 1"));
        list1.Add(new Person(2, "Name 2"));
        list1.Add(new Person(3, "Name 3"));
        list1.Add(new Person(4, "Name 4"));
        list1.Add(new Person(5, "Name 5"));
        return list1;
    }

    public List<Person> DataSource2()
    {
        List<Person> list1 = new List<Person>();
        list1.Add(new Person(6, "Name 6"));
        list1.Add(new Person(7, "Name 7"));
        list1.Add(new Person(8, "Name 8"));
        list1.Add(new Person(9, "Name 9"));
        list1.Add(new Person(10, "Name 10"));
        return list1;
    }
}